<script>
import useColumns from "./columns";
import { REFER } from "@/components/popover-select/api";
import { ADD, CODE } from "@/api/business/purchase/contract";

export default {
  name: "AddDrawer",
  props: {
    selectData: {
      type: [Array],
      require: true,
    },
    dict: {
      type: Object,
      require: true,
    },
    addType: {
      type: String,
      default: "add",
    },
  },
  components: {
    ElSuperForm: () => import("@/components/super-form/index.vue"),
    ElSuperTable: () => import("@/components/super-table/index.vue"),
    ElPopoverSelectV2: () => import("@/components/popover-select-v2/index.vue"),
  },
  data() {
    const {
      TabColumns,
      TableColumns,
      TabColumns: [
        {
          item: { key: tabName },
        },
      ],
    } = useColumns();
    const rules = this.$init.rules([...TabColumns, ...TableColumns]);
    const params = this.$init.params([...TabColumns, ...TableColumns]);
    return {
      width: "100%",
      visible: false,
      loading: false,
      rules: rules,
      params: params,
      tabName: tabName,
      TabColumns: TabColumns,
      TableColumns: TableColumns,
    };
  },
  computed: {
    title: {
      get() {
        const { addType } = this.$props;
        if (addType === "add") {
          this.params.source = "自制";
          return "新 增";
        }
        if (addType === "record") {
          this.params.source = "期初补录";
          return "期初补录";
        }
      },
      set() {},
    },
  },
  watch: {},
  methods: {
    //
    async fetchCode() {
      try {
        // try
        this.loading = true;
        const data = await CODE();
        if (data) {
          this.params.code = data;
          return true;
        } else {
          return false;
        }
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        this.loading = false;
      }
    },
    //
    async changeMaterialName(prop) {
      const { row } = prop;
      const { rateCode } = row;
      try {
        // try
        this.loading = true;
        const { code, rows } = await REFER({
          search: rateCode,
          type: "TAX_RATE_PARAM",
        });
        if (code === 200) {
          const [{ ntaxrate }] = rows;
          row.tax = ntaxrate === "0E-8" ? "0.00000000" : ntaxrate;
        }
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        this.loading = false;
      }
    },
    //
    async open() {
      const {
        user: {
          deptId: puDept,
          deptName: puDeptName,
          name: buyer,
          nickName: buyerName,
          orgId: puOrg,
          orgName: puOrgName,
        },
      } = this.$store.state;
      this.params.puOrg = puOrg;
      this.params.puOrgName = puOrgName;
      this.params.buyer = buyer;
      this.params.buyerName = buyerName;
      this.params.puDept = puDept;
      this.params.puDeptName = puDeptName;
      const { id, code, name } = await this.getCurrency("人民币");
      this.params.currency = id;
      this.params.currencyCode = code;
      this.params.currencyName = name;
      this.visible = await this.fetchCode();
    },
    async getCurrency(search) {
      let page = { pageNum: 1, pageSize: 10 };

      const { code, rows } = await REFER(
        {
          isPage: true,
          search,
          type: "CURRENCY_PARAM",
        },
        page
      );
      if (code == 200) {
        return rows[0];
      }
    },
    //
    async hide() {
      const {
        TabColumns,
        TableColumns,
        TabColumns: [
          {
            item: { key: tabName },
          },
        ],
      } = useColumns();
      this.visible = false;
      this.tabName = tabName;
      this.params = this.$init.params([...TabColumns, ...TableColumns]);
    },
    //
    async useRowAdd(prop) {
      const { TableColumns } = this.TabColumns.find(
        ({ item: { key } }) => key === prop
      );
      this.params[prop].push(this.$init.params(TableColumns));
    },
    //
    async useRowRemove(prop, scope) {
      const { $index } = scope;
      this.params[prop].splice($index, 1);
    },
    //
    async useSubmit(prop) {
      this.$refs[prop].validate(async (valid) => {
        if (valid) {
          try {
            // try
            this.loading = true;
            const params = { ...this.params };
            const { msg, code } = await ADD(params);
            if (code === 200) {
              this.hide();
              this.$emit("success");
              this.$notify.success(msg);
            }
          } catch (err) {
            // catch
            console.error(err);
          } finally {
            // finally
            this.loading = false;
          }
        } else {
          return false;
        }
      });
    },
  },
  created() {},
  mounted() {},
  destroyed() {},
};
</script>
<template>
  <el-button v-bind="$attrs" v-on="$listeners" @click="open">
    {{ title }}
    <el-drawer
      :size="width"
      :title="title"
      :visible.sync="visible"
      append-to-body
      destroy-on-close
      :show-close="false"
      @close="hide"
    >
      <div
        slot="title"
        style="
          display: flex;
          justify-content: space-between;
          align-items: center;
        "
      >
        <h3>{{ title }}</h3>
        <div style="text-align: right">
          <el-button
            type="primary"
            :size="$attrs.size"
            :loading="loading"
            @click="useSubmit('superForm')"
            >确 认</el-button
          >
          <el-button :size="$attrs.size" :loading="loading" @click="hide"
            >取 消</el-button
          >
        </div>
      </div>

      <el-super-form
        v-model="params"
        :dict="dict"
        :rules="rules"
        :size="$attrs.size"
        :columns="TableColumns"
        ref="superForm"
        label-width="auto"
        label-position="right"
        style="padding: 20px"
      ></el-super-form>

      <el-tabs v-model="tabName" style="margin: 0 20px">
        <el-tab-pane
          v-for="{ item, TableColumns: columns } in TabColumns"
          :key="item.key"
          :label="item.title"
          :name="item.key"
          lazy
        >
          <el-super-table
            v-model="params[item.key]"
            :dict="dict"
            :ref="tabName"
            :columns="columns"
            :size="$attrs.size"
            index
          >
            <template slot="materialName" slot-scope="scope">
              <component
                v-bind="scope.attr"
                v-model="scope.row[scope.item.key]"
                :size="$attrs.size"
                :source.sync="scope.row"
                @change="changeMaterialName(scope)"
              >
              </component>
            </template>
            <el-table-column fixed="right" label="操作" width="75">
              <template slot="header" slot-scope="scope">
                <el-button
                  type="text"
                  :size="$attrs.size"
                  @click="useRowAdd(tabName)"
                  >增行
                </el-button>
              </template>
              <template slot-scope="scope">
                <el-button
                  type="text"
                  :size="$attrs.size"
                  @click.native.prevent="useRowRemove(tabName, scope)"
                  >删行
                </el-button>
              </template>
            </el-table-column>
          </el-super-table>
        </el-tab-pane>
      </el-tabs>
    </el-drawer>
  </el-button>
</template>
